org.apache.sysds.hops

## Enum OptimizerUtils.OptimizationLevel

- java.lang.Object
- - java.lang.Enum<OptimizerUtils.OptimizationLevel>
  - - org.apache.sysds.hops.OptimizerUtils.OptimizationLevel

- All Implemented Interfaces:
    Serializable, Comparable<OptimizerUtils.OptimizationLevel>
  Enclosing class:
    OptimizerUtils

      public static enum OptimizerUtils.OptimizationLevel
      extends Enum<OptimizerUtils.OptimizationLevel>

  Optimization Types for Compilation O0 STATIC - Decisions for scheduling operations on CP/MR are based on predefined set of rules, which check if the dimensions are below a fixed/static threshold (OLD Method of choosing between CP and MR). The optimization scope is LOCAL, i.e., per statement block. Advanced rewrites like constant folding, common subexpression elimination, or inter procedural analysis are NOT applied. O1 MEMORY_BASED - Every operation is scheduled on CP or MR, solely based on the amount of memory required to perform that operation. It does NOT take the execution time into account. The optimization scope is LOCAL, i.e., per statement block. Advanced rewrites like constant folding, common subexpression elimination, or inter procedural analysis are NOT applied. O2 MEMORY_BASED - Every operation is scheduled on CP or MR, solely based on the amount of memory required to perform that operation. It does NOT take the execution time into account. The optimization scope is LOCAL, i.e., per statement block. All advanced rewrites are applied. This is the default optimization level of SystemDS. O3 GLOBAL TIME_MEMORY_BASED - Operation scheduling on CP or MR as well as many other rewrites of data flow properties such as block size, partitioning, replication, vectorization, etc are done with the optimization objective of minimizing execution time under hard memory constraints per operation and execution context. The optimization scope if GLOBAL, i.e., program-wide. All advanced rewrites are applied. This optimization level requires more optimization time but has higher optimization potential. O4 DEBUG MODE - All optimizations, global and local, which interfere with breakpoints are NOT applied. This optimization level is REQUIRED for the compiler running in debug mode.

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `O0_LOCAL_STATIC`
    `O1_LOCAL_MEMORY_MIN`
    `O2_LOCAL_MEMORY_DEFAULT`
    `O3_LOCAL_RESOURCE_TIME_MEMORY`
    `O4_GLOBAL_TIME_MEMORY`
    `O5_DEBUG_MODE`

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static OptimizerUtils.OptimizationLevel` | `valueOf(String name)` Returns the enum constant of this type with the specified name.
    `static OptimizerUtils.OptimizationLevel[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `compareTo, equals, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### O0_LOCAL_STATIC

          public static final OptimizerUtils.OptimizationLevel O0_LOCAL_STATIC

    - #### O1_LOCAL_MEMORY_MIN

          public static final OptimizerUtils.OptimizationLevel O1_LOCAL_MEMORY_MIN

    - #### O2_LOCAL_MEMORY_DEFAULT

          public static final OptimizerUtils.OptimizationLevel O2_LOCAL_MEMORY_DEFAULT

    - #### O3_LOCAL_RESOURCE_TIME_MEMORY

          public static final OptimizerUtils.OptimizationLevel O3_LOCAL_RESOURCE_TIME_MEMORY

    - #### O4_GLOBAL_TIME_MEMORY

          public static final OptimizerUtils.OptimizationLevel O4_GLOBAL_TIME_MEMORY

    - #### O5_DEBUG_MODE

          public static final OptimizerUtils.OptimizationLevel O5_DEBUG_MODE

  - ### Method Detail

    - #### values

          public static OptimizerUtils.OptimizationLevel[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (OptimizerUtils.OptimizationLevel c : OptimizerUtils.OptimizationLevel.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static OptimizerUtils.OptimizationLevel valueOf(String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `IllegalArgumentException` - if this enum type has no constant with the specified name
        `NullPointerException` - if the argument is null

Copyright © 2021 The Apache Software Foundation. All rights reserved.